# Method: accounts.customers.listPurchasableSkus

- [HTTP request](https://docs.cloud.google.com/channel/docs/reference/rest/v1/accounts.customers/listPurchasableSkus#body.HTTP_TEMPLATE)
- [Path parameters](https://docs.cloud.google.com/channel/docs/reference/rest/v1/accounts.customers/listPurchasableSkus#body.PATH_PARAMETERS)
- [Query parameters](https://docs.cloud.google.com/channel/docs/reference/rest/v1/accounts.customers/listPurchasableSkus#body.QUERY_PARAMETERS)
- [Request body](https://docs.cloud.google.com/channel/docs/reference/rest/v1/accounts.customers/listPurchasableSkus#body.request_body)
- [Response body](https://docs.cloud.google.com/channel/docs/reference/rest/v1/accounts.customers/listPurchasableSkus#body.response_body)
  - [JSON representation](https://docs.cloud.google.com/channel/docs/reference/rest/v1/accounts.customers/listPurchasableSkus#body.ListPurchasableSkusResponse.SCHEMA_REPRESENTATION)
- [Authorization scopes](https://docs.cloud.google.com/channel/docs/reference/rest/v1/accounts.customers/listPurchasableSkus#body.aspect)
- [CreateEntitlementPurchase](https://docs.cloud.google.com/channel/docs/reference/rest/v1/accounts.customers/listPurchasableSkus#CreateEntitlementPurchase)
  - [JSON representation](https://docs.cloud.google.com/channel/docs/reference/rest/v1/accounts.customers/listPurchasableSkus#CreateEntitlementPurchase.SCHEMA_REPRESENTATION)
- [ChangeOfferPurchase](https://docs.cloud.google.com/channel/docs/reference/rest/v1/accounts.customers/listPurchasableSkus#ChangeOfferPurchase)
  - [JSON representation](https://docs.cloud.google.com/channel/docs/reference/rest/v1/accounts.customers/listPurchasableSkus#ChangeOfferPurchase.SCHEMA_REPRESENTATION)
- [ChangeType](https://docs.cloud.google.com/channel/docs/reference/rest/v1/accounts.customers/listPurchasableSkus#ChangeType)
- [PurchasableSku](https://docs.cloud.google.com/channel/docs/reference/rest/v1/accounts.customers/listPurchasableSkus#PurchasableSku)
  - [JSON representation](https://docs.cloud.google.com/channel/docs/reference/rest/v1/accounts.customers/listPurchasableSkus#PurchasableSku.SCHEMA_REPRESENTATION)
- [Try it!](https://docs.cloud.google.com/channel/docs/reference/rest/v1/accounts.customers/listPurchasableSkus#try-it)

Lists the following:

- SKUs that you can purchase for a customer
- SKUs that you can upgrade or downgrade for an entitlement.

Possible error codes:

- PERMISSION_DENIED: The customer doesn't belong to the reseller.
- INVALID_ARGUMENT: Required request parameters are missing or invalid.

### HTTP request

`GET https://cloudchannel.googleapis.com/v1/{customer=accounts/*/customers/*}:listPurchasableSkus`

The URL uses [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `customer` | `string` Required. The resource name of the customer to list SKUs for. Format: accounts/{account_id}/customers/{customer_id}. |

### Query parameters

| Parameters ||
|---|---|
| `pageSize` | `integer` Optional. Requested page size. Server might return fewer results than requested. If unspecified, returns at most 100 SKUs. The maximum value is 1000; the server will coerce values above 1000. |
| `pageToken` | `string` Optional. A token for a page of results other than the first page. |
| `languageCode` | `string` Optional. The BCP-47 language code. For example, "en-US". The response will localize in the corresponding language code, if specified. The default value is "en-US". |
| Union parameter `purchase_option`. Defines the intended purchase. `purchase_option` can be only one of the following: ||
| `createEntitlementPurchase` | ``object (`https://docs.cloud.google.com/channel/docs/reference/rest/v1/accounts.customers/listPurchasableSkus#CreateEntitlementPurchase`)`` List SKUs for CreateEntitlement purchase. |
| `changeOfferPurchase` | ``object (`https://docs.cloud.google.com/channel/docs/reference/rest/v1/accounts.customers/listPurchasableSkus#ChangeOfferPurchase`)`` List SKUs for ChangeOffer purchase with a new SKU. |

### Request body

The request body must be empty.

### Response body

Response message for customers.listPurchasableSkus.

If successful, the response body contains data with the following structure:

| JSON representation |
|---|
| ``` { "purchasableSkus": [ { object (`https://docs.cloud.google.com/channel/docs/reference/rest/v1/accounts.customers/listPurchasableSkus#PurchasableSku`) } ], "nextPageToken": string } ``` |

| Fields ||
|---|---|
| `purchasableSkus[]` | ``object (`https://docs.cloud.google.com/channel/docs/reference/rest/v1/accounts.customers/listPurchasableSkus#PurchasableSku`)`` The list of SKUs requested. |
| `nextPageToken` | `string` A token to retrieve the next page of results. |

### Authorization scopes

Requires the following OAuth scope:

- `https://www.googleapis.com/auth/apps.order`

For more information, see the [Authentication Overview](https://docs.cloud.google.com/docs/authentication#authorization-gcp).

## CreateEntitlementPurchase

List SKUs for a new entitlement. Make the purchase using `https://docs.cloud.google.com/channel/docs/reference/rest/v1/accounts.customers.entitlements/create#google.cloud.channel.v1.CloudChannelService.CreateEntitlement`.

| JSON representation |
|---|
| ``` { "product": string } ``` |

| Fields ||
|---|---|
| `product` | `string` Required. List SKUs belonging to this Product. Format: products/{productId}. Supports products/- to retrieve SKUs for all products. |

## ChangeOfferPurchase

List SKUs for upgrading or downgrading an entitlement. Make the purchase using `https://docs.cloud.google.com/channel/docs/reference/rest/v1/accounts.customers.entitlements/changeOffer#google.cloud.channel.v1.CloudChannelService.ChangeOffer`.

| JSON representation |
|---|
| ``` { "entitlement": string, "changeType": enum (`https://docs.cloud.google.com/channel/docs/reference/rest/v1/accounts.customers/listPurchasableSkus#ChangeType`) } ``` |

| Fields ||
|---|---|
| `entitlement` | `string` Required. Resource name of the entitlement. Format: accounts/{account_id}/customers/{customer_id}/entitlements/{entitlement_id} |
| `changeType` | ``enum (`https://docs.cloud.google.com/channel/docs/reference/rest/v1/accounts.customers/listPurchasableSkus#ChangeType`)`` Required. Change Type for the entitlement. |

## ChangeType

Change Type enum.

| Enums ||
|---|---|
| `CHANGE_TYPE_UNSPECIFIED` | Not used. |
| `UPGRADE` | SKU is an upgrade on the current entitlement. |
| `DOWNGRADE` | SKU is a downgrade on the current entitlement. |

## PurchasableSku

SKU that you can purchase. This is used in ListPurchasableSku API response.

| JSON representation |
|---|
| ``` { "sku": { object (`https://docs.cloud.google.com/channel/docs/reference/rest/v1/Sku`) } } ``` |

| Fields ||
|---|---|
| `sku` | ``object (`https://docs.cloud.google.com/channel/docs/reference/rest/v1/Sku`)`` SKU |